## uw-imap 2007f~dfsg

=== Makefile ===
# ========================================================================
# Copyright 1988-2008 University of Washington
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# 
# ========================================================================

# Program:	IMAP Toolkit Makefile
#
# Author:	Mark Crispin
#		UW Technology
#		Seattle, WA  98195
#		Internet: MRC@Washington.EDU
#
# Date:		7 December 1989
# Last Edited:	12 May 2008


# Normal command to build IMAP toolkit:
#  make <port> [EXTRAAUTHENTICATORS=xxx] [EXTRADRIVERS=xxx] [EXTRACFLAGS=xxx]
#	       [PASSWDTYPE=xxx] [SSLTYPE=xxx] [IP=n]


# Port name.  These refer to the *standard* compiler on the given system.
# This means, for example, that the hpx port is for HP's compiler and not for
# a non-standard compiler such as gcc.
#
# If you are using gcc and it is not the standard compiler on your system, try
# using an ANSI port that is close to what you have.  For example, if your
# system is SVR4ish, try a32 or lnx; if it's more BSDish, try nxt, mct, or bsi.
#
# The following ports are bundled:
# a32	AIX 3.2 for RS/6000
# a41	AIX 4.1 for RS/6000
# a52	Attempt at AIX 5.2
# aix	AIX/370 (not RS/6000!!)
# ami	AmigaDOS
# am2	AmigaDOS with a 68020+
# ama	AmigaDOS using AS225R2
# amn	AmigaDOS with a 680x0 using "new" socket library
# aos	AOS for RT
# art	AIX 2.2.1 for RT
# asv	Altos SVR4
# aux	A/UX
# bs3	BSD/i386 3.0 and higher
# bsd	generic BSD 4.3 (as in ancient 1980s version)
# bsf	FreeBSD
# bsi	BSD/i386
# bso	OpenBSD (yes, yet another one...)
# cvx	Convex
# cyg	Cygwin
# d-g	Data General DG/UX prior to 5.4 (d41 port no longer exists)
# d54	Data General DG/UX 5.4
# do4	Apollo Domain/OS sr10.4
# dpx	Bull DPX/2 B.O.S.
# drs	ICL DRS/NX
# dyn	Dynix
# epx	EP/IX
# ga4	GCC AIX 4.x for RS/6000
# gas	GCC Altos SVR4
# gcs	GCC Solaris with Blastwave Community Open Source Software
# gh9   GCC HP-UX 9.x
# ghp	GCC HP-UX 10.x
# ghs	GCC HP-UX 10.x with Trusted Computer Base
# go5	GCC 2.7.1 (95q4 from Skunkware _not_ 98q2!) SCO Open Server 5.0.x
# gsc	GCC Santa Cruz Operation
# gsg	GCC SGI
# gso	GCC Solaris
# gsu	GCC SUN-OS
# gul	GCC RISC Ultrix (DEC-5000)
# h11	HP-UX 11i
# hpp	HP-UX 9.x (see gh9)
# hpx	HP-UX 10.x (see ghp, ghs, hxd, and shp)
# hxd	HP-UX 10.x with DCE security (see shp)
# isc	Interactive Systems
# ldb	Debian Linux
# lfd	Fedora Core 4
# ln8	Linux for Nokia N800
# lnx	Linux with traditional passwords and crypt() in the C library
#	 (see lnp, sl4, sl5, and slx)
# lnp	Linux with Pluggable Authentication Modules (PAM)
# lmd	Mandrake Linux
# lr5	RedHat Enterprise 5 and later (same as lfd)
# lrh	RedHat Linux 7.2 and later
# lsu	SuSE Linux (same as lrh)
# lyn	LynxOS
# mct	MachTen
# mnt	Atari ST Mint (not MacMint)
# neb	NetBSD
# nec	NEC UX
# nto	QNX Neutrine RTP
# nxt	NEXTSTEP
# nx3	NEXTSTEP 3.x
# osf	OSF/1 (see sos, os4)
# os4	OSF/1 (Digital UNIX) 4
# osi	Apple iPhone and iPod Touch
# osx	Mac OS X
# oxp	Mac OS X with Pluggable Authentication Modules (PAM)
# ptx	PTX
# pyr	Pyramid
# qnx	QNX 4
# s40	SUN-OS 4.0 (*not* Solaris)
# sc5	SCO Open Server 5.0.x (see go5)
# sco	Santa Cruz Operation (see sc5, go5)
# shp	HP-UX with Trusted Computer Base
# sgi	Silicon Graphics IRIX
# sg6	Silicon Graphics IRIX 6.5
# sl4	Linux using -lshadow to get the crypt() function
# sl5	Linux with shadow passwords, no extra libraries
# slx	Linux using -lcrypt to get the crypt() function
# snx	Siemens Nixdorf SININX or Reliant UNIX
# soc	Solaris with /opt/SUNWspro/bin/cc
# sol	Solaris (won't work unless "ucbcc" works -- use gso instead)
# sos	OSF/1 with SecureWare
# ssn	SUN-OS with shadow password security
# sua	Windows Vista (Enterprise or Ultima) Subsystem for Unix Applications
# sun	SUN-OS 4.1 or better (*not* Solaris) (see ssn)
# sv2	SVR2 on AT&T PC-7300 (incomplete port)
# sv4	generic SVR4
# ult	RISC Ultrix (DEC-5000)
# uw2	UnixWare SVR4.2
# vul	VAX Ultrix
# vu2	VAX Ultrix 2.3 (e.g. for VAXstation-2000 or similar old version)


# Extra authenticators (e.g. OTP, Kerberos, etc.).  Adds linkage for
# auth_xxx.c and executes Makefile.xxx, where xxx is the name of the
# authenticator.  Some authenticators are only available from third parties.
#
# The following extra authenticators are bundled:
# gss	Kerberos V

EXTRAAUTHENTICATORS=


# Additional mailbox drivers.  Add linkage for xxxdriver.  Some drivers are
# only available from third parties.
#
# The following extra drivers are bundled:
# mbox	if file "mbox" exists on the home directory, automatically moves mail
#	 from the spool directory to "mbox" and uses "mbox" as INBOX.

EXTRADRIVERS=mbox


# Plaintext password type.  Defines how plaintext password authentication is
# done on this system.
#
# The following plaintext login types are bundled:
# afs	AFS authentication database
# dce	DCE authentication database
# gss	Kerberos V
# nul	plaintext authentication never permitted
# pam	PAM authentication (note: for Linux, you should use the "lnp" port
#	 instead of setting this...also, you may have to modify PAMLDFLAGS
#	 in the imap-[]/src/osdep/unix/Makefile
# pmb	PAM authentication for broken implementations such as Solaris.
#	 you may have to modify PAMLDFLAGS
# std	system standard (typically passwd file), determined by port
# two	try alternative (defined by CHECKPWALT), then std

PASSWDTYPE=std


# SSL type.  Defines whether or not SSL support is on this system
#
# The following SSL types are bundled:
# none	no SSL support
# unix	SSL support using OpenSSL
# nopwd	SSL support using OpenSSL, and plaintext authentication permitted only
#	in SSL/TLS sessions
# sco	link SSL before other libraries (for SCO systems)
# unix.nopwd	same as nopwd
# sco.nopwd	same as nopwd, plaintext authentication in SSL/TLS only
#
# SSLTYPE=nopwd is now the default as required by RFC 3501

SSLTYPE=nopwd


# IP protocol version
#
# The following IP protocol versions are defined:
# o	IPv4 support, no DNS (truly ancient systems)
# 4	(default) IPv4 support only
# 6	IPv6 and IPv4 support

IP=4
IP6=6


# The following extra compilation flags are defined.  None of these flags are
# recommended.  If you use these, include them in the EXTRACFLAGS.
#
# -DDISABLE_POP_PROXY
#	By default, the ipop[23]d servers offer POP->IMAP proxy access,
#	which allow a POP client to access mail on an IMAP server by using the
#	POP server as a go-between.  Setting this option disables this
#	facility.
#
# -DOLDFILESUFFIX=\"xxx\"
#	Change the default suffix appended to the backup .newsrc file from
#	"old".
#
# -DSTRICT_RFC822_TIMEZONES
#	Disable recognition of the non-standard UTC (0000), MET (+0100),
#	EET (+0200), JST (+0900), ADT (-0300), AST (-0400), YDT (-0800),
#	YST (-0900), and HST (-1000) symbolic timezones.
#
# -DBRITISH_SUMMER_TIME
#	Enables recognition of non-standard symbolic timezone BST as +0100.
#
# -DBERING_STANDARD_TIME
#	Enables recognition of non-standard symbolic timezone BST as -1100.
#
# -DNEWFOUNDLAND_STANDARD_TIME
#	Enables recognition of non-standard symbolic timezone NST as -0330.
#
# -DNOME_STANDARD_TIME
#	Enables recognition of non-standard symbolic timezone NST as -1100.
#
# -DSAMOA_STANDARD_TIME
#	Enables recognition of non-standard symbolic timezone SST as -1100.
#				
# -DY4KBUGFIX
#	Turn on the Y4K bugfix (yes, that's year 4000).  It isn't well-known,
#	but century years evenly divisible by 4000 are *not* leap years in the
#	Gregorian calendar.  A lot of "Y2K compilant" software does not know
#	about this rule.  Remember to turn this on sometime in the next 2000
#	years.
#
# -DUSEORTHODOXCALENDAR
#	Use the more accurate Eastern Orthodox calendar instead of the
#	Gregorian calendar.  The century years which are leap years happen
#	at alternating 400 and 500 year intervals without shifts every 4000
#	years.  The Orthodox and Gregorian calendars diverge by 1 day for
#	gradually-increasing intervals, starting at 2800-2900, and becoming
#	permanent at 48,300.
#
# -DUSEJULIANCALENDAR
#	Use the less accurate Julian calendar instead of the Gregorian
#	calendar.  Leap years are every 4 years, including century years.
#	My apologies to those in the English-speaking world who object to
#	the reform of September 2, 1752 -> September 14, 1752, since this
#	code still uses January 1 (which Julius Ceasar decreed as the start
#	of the year, which since 153 BCE was the day that Roman consuls
#	took office), rather than the traditional March 25 used by the
#	British.  As of 2005, the Julian calendar and the Gregorian calendar
#	diverge by 15 days.

EXTRACFLAGS=


# Extra linker flags (additional/alternative libraries, etc.)

EXTRALDFLAGS=


# Special make flags (e.g. to override make environment variables)

EXTRASPECIALS=
SPECIALS=


# Normal commands

CAT=cat
CD=cd
LN=ln -s
MAKE=make
MKDIR=mkdir
BUILDTYPE=rebuild
RM=rm -rf
SH=sh
SYSTEM=unix
TOOLS=tools
TOUCH=touch


# Primary build command

BUILD=$(MAKE) build EXTRACFLAGS='$(EXTRACFLAGS)'\
 EXTRALDFLAGS='$(EXTRALDFLAGS)'\
 EXTRADRIVERS='$(EXTRADRIVERS)'\
 EXTRAAUTHENTICATORS='$(EXTRAAUTHENTICATORS)'\
 PASSWDTYPE=$(PASSWDTYPE) SSLTYPE=$(SSLTYPE) IP=$(IP)\
 EXTRASPECIALS='$(EXTRASPECIALS)'


# Make the IMAP Toolkit

all:	c-client SPECIALS rebuild bundled

c-client:
	@echo Not processed yet.  In a first-time build, you must specify
	@echo the system type so that the sources are properly processed.
	@false


SPECIALS:
	echo $(SPECIALS) > SPECIALS

# Note on SCO you may have to set LN to "ln".

a32 a41 a52 aix bs3 bsi d-g d54 do4 drs epx ga4 gas gh9 ghp ghs go5 gsc gsg gso gul h11 hpp hpx lnp lyn mct mnt nec nto nxt nx3 osf os4 ptx qnx sc5 sco sgi sg6 shp sl4 sl5 slx snx soc sol sos uw2: an
	$(BUILD) BUILDTYPE=$@

# If you use sv4, you may find that it works to move it to use the an process.
# If so, you probably will want to delete the "-Dconst=" from the sv4 CFLAGS in
# the c-client Makefile.

aos art asv aux bsd cvx dpx dyn isc pyr sv4 ult vul vu2: ua
	$(BUILD) BUILDTYPE=$@


# Knotheads moved Kerberos and SSL locations on these platforms

# Paul Vixie claims that all FreeBSD versions have working IPv6

bsf:	an
	$(TOUCH) ip6
	$(BUILD) BUILDTYPE=$@ IP=$(IP6) \
	PASSWDTYPE=pam \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/etc/ssl/certs SSLKEYS=/etc/ssl/private GSSINCLUDE=/usr/include GSSLIB=/usr/lib PAMLDFLAGS=-lpam"

# I assume that Theo did the right thing for IPv6.  OpenBSD does not have PAM.

bso:	an
	$(TOUCH) ip6
	$(BUILD) BUILDTYPE=$@ IP=$(IP6) \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/etc/ssl SSLKEYS=/etc/ssl/private GSSINCLUDE=/usr/include GSSLIB=/usr/lib"

# Info from Joel Reicher about NetBSD SSL paths.  I assume it has PAM because pam is in NetBSD sources...

neb:	an
	$(TOUCH) ip6
	$(BUILD) BUILDTYPE=$@ IP=$(IP6) \
	PASSWDTYPE=pam \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/etc/openssl/certs SSLKEYS=/etc/openssl/private GSSINCLUDE=/usr/include GSSLIB=/usr/lib PAMLDFLAGS=-lpam"

cyg:	an
	$(BUILD) BUILDTYPE=cyg \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/usr/ssl/certs SSLKEYS=/usr/ssl/certs"

gcs:	an
	$(BUILD) BUILDTYPE=gso \
	SPECIALS="SSLINCLUDE=/opt/csw/include/openssl SSLLIB=/opt/csw/lib SSLCERTS=/opt/csw/ssl/certs SSLKEYS=/opt/csw/ssl/certs"

ldb:	an
	$(BUILD) BUILDTYPE=lnp IP=$(IP6) \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/etc/ssl/certs SSLKEYS=/etc/ssl/private GSSINCLUDE=/usr/include GSSLIB=/usr/lib MAILSPOOL=/var/mail"

lfd:	an
	$(BUILD) BUILDTYPE=lnp IP=$(IP6) \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/etc/pki/tls/certs SSLKEYS=/etc/pki/tls/private GSSDIR=/usr/kerberos"

ln8:	an
	$(TOUCH) ip6
	$(BUILD) BUILDTYPE=slx IP=$(IP6) \
	SPECIALS="SSLINCLUDE=/usr/include/openssl SSLLIB=/usr/lib SSLCERTS=/usr/lib/ssl/certs MAILSPOOL=/var/mail"


# RHE5 does not have the IPv6 bug

lr5:	an
	$(TOUCH) ip6
	$(BUILD) BUILDTYPE=lnp IP=$(IP6) \

=== debian/changelog ===
uw-imap (8:2007f~dfsg-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/rules: replace deprecated . with : in chown call
  * Stop ignoring build errors
  * Fix FTBFS with gcc-14 (Closes: #1075612)
  * Declare Rules-Requires-Root: binary-targets

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 31 Dec 2024 10:43:13 +0100

uw-imap (8:2007f~dfsg-7) unstable; urgency=low

  * 2014_openssl1.1.1_sni.patch (new, from Ubuntu): Use SNI when building
    with OpenSSL 1.1.1 / TLSv1.3 support, since some servers (e.g.,
    imap.gmail.com, imap.mail.att.net) require SNI on TLSv1.3 to pass
    certificate verification (Closes: #916041). Thanks to Ed Spiridonov
    and David Zuelke.
  * 1005_poll.patch: Use poll(2) instead of select(2) for SSL connections
    as well (Closes: #770022).
  * 1001_shlibs.patch, 2012_krb5_multidev.patch, debian/rules: Make cross
    compilation work by not hard-coding the compiler and by letting
    dh_auto_build set the variables correctly (Closes: #876074). Thanks to
    Helmut Grohne.
  * 1002_fix_ftbfs.patch: Correct the order of arguments to syslog(),
    which has been wrong all these years, and rename to more descriptive
    1002_flock_fix_syslog_args.patch.
  * Bump Standards-Version to 4.4.0. (Not renaming libc-client2007e-dev
    now, but if the soname should need to change sometime in the future.)

 -- Magnus Holmgren <holmgren@debian.org>  Mon, 26 Aug 2019 22:52:52 +0200

uw-imap (8:2007f~dfsg-6) unstable; urgency=medium

  * [CVE-2018-19518] 2013_disable_rsh.patch (new): Disable access to IMAP
    mailboxes through running imapd over rsh, and therefore ssh (Closes:
    #914632). Code using the library can enable it with tcp_parameters()
    after making sure that the IMAP server name is sanitized.
  * Change Priority: extra of -dev package to optional.
  * Move git repository to salsa.debian.org.

 -- Magnus Holmgren <holmgren@debian.org>  Wed, 27 Feb 2019 00:08:08 +0100

uw-imap (8:2007f~dfsg-5) unstable; urgency=low

  * 1006_openssl1.1_autoverify.patch (new): Use new features for
    validating certificates when building with OpenSSL 1.1 (Closes:
    #828589). Thanks to Sebastian Andrzej Siewior and Kurt Roeckx for
    help.
  * Switch to Debhelper compat level 9.
  * Bump Standards-Version to 3.9.8.
  * Update Build-Depends with cdbs.

 -- Magnus Holmgren <holmgren@debian.org>  Wed, 23 Nov 2016 22:25:10 +0100

uw-imap (8:2007f~dfsg-4) unstable; urgency=medium

  * 2012_krb5_multidev.patch: Fix typo mixing up --cflags and --libs
    causing libc-client not to be linked to the kerberos libraries
    (Closes: #766526).
  * Tell d-shlibmove to substitute krb5-multidev for libkrb5-dev.

 -- Magnus Holmgren <holmgren@debian.org>  Fri, 24 Oct 2014 22:40:53 +0200

uw-imap (8:2007f~dfsg-3) unstable; urgency=low

  * 2012_krb5_multidev.patch (new): Depend on krb5-multidev rather than
    libkrb5-dev (Closes: #745333). Thanks to Jelmer Vernooij.
  * 1005_poll.patch (new): Use poll(2) instead of select(2) to support
    more than 1024 file descriptors (Closes: #478193). Thanks to Ben
    Smithurst.
  * Bump Standards-Version to 3.9.6.

 -- Magnus Holmgren <holmgren@debian.org>  Sun, 19 Oct 2014 23:01:35 +0200

uw-imap (8:2007f~dfsg-2) unstable; urgency=medium

  * New maintainer (Closes: #686448).
  * Disable unnecessarily strict version check (Closes: #682256).

 -- Magnus Holmgren <holmgren@debian.org>  Thu, 25 Oct 2012 23:00:39 +0200

uw-imap (8:2007f~dfsg-1) unstable; urgency=low

  * New upstream release.
    Closes: bug#656074. Thanks to Ivan Shmakov.

  * Stop shipping uw-imapd or ipopd daemons: Code is in bad shape and
    better alternatives exist.
  * Lower Priority of libc-client-*-dev to extra: Depends on similarly
    prioritized comerr-dev and libkrb5-dev.
  * Drop locally included CDBS snippets: Adopted upstream.
  * Use dpkg source format 3.0 (quilt).
    Stop including patchsys-quilt.mk and update README.source to not
    mention quilt.
    Git-ignore quilt .pc subidr.
  * Update rules file licensing header:
    + Extend years, and list them explicitly.
    + Refer to FSF web URL (not postal address).
  * Bump debhelper compat level to 7.
  * Unfuzz patches and refresh using quilt shortening options -pab
    --no-timestamps --no-index.
  * Fix use target build-arch (not build).
    Closes: bug#666288. Thanks to Lucas Nussbaum.
  * Add patch 1003 to properly zero out len when mail_fetch_body()
    returns an empty string.
    Closes: bug#635839. Thanks to Vladimir Kolesnikov and Daniel T Chen.
  * Add patch 1004 to implement support for IMAP extension METADATA
    (rfc5464).
    Closes: bug#456591. Thanks to Mathieu Parent and Kolab project.
  * Explicitly pass LDFLAGS to build, to hopefully include eventual
    hardening flags.
  * Extend patch 1001 to explicitly link against all used Kerberos libs.
    Closes: bug#558968. Thanks to Peter Fritzsche and Matthias Klose.
  * Use anonscm.debian.org for Vcs-Browser field.
  * Update package relations:
    + Sort and newline-delimit package relations.
    + Stop build-depending on quilt or patchutils: unneeded with source
      version 3.0 (quilt).
    + Relax to build-depend unversioned on debhelper and devscripts:
      Required versions satisfied even in oldstable.
    + Tighten build-dependency on cdbs.
    + Stop build-depending on perl: Was used in a CDBS snippet which is
      now dropped.
    + Stop build-depending on po-debconf: Was used for debconf of daemon
      packages which are now dropped.
  * Rewrite copyright file using format 1.0.
  * Fix version in NEWS entry, to silence lintian (sadly it is 6 years
    too late to be of real benefit).
  * Drop stray substvars file from source packaging. Thanks to lintian.
  * Hardcode CDBS-resolved build flags, and stuff CPPFLAGS into CFLAGS,
    to enable hardening.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 29 Jun 2012 13:07:15 +0200

uw-imap (8:2007e~dfsg-3.3) unstable; urgency=low

  * Non-maintainer upload.


=== debian/control ===
Source: uw-imap
Priority: optional
Section: mail
Maintainer: Magnus Holmgren <holmgren@debian.org>
Standards-Version: 4.4.0
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 licensecheck,
 libpam-dev,
 krb5-multidev,
 comerr-dev,
 libssl-dev,
 d-shlibs
Vcs-Git: https://salsa.debian.org/holmgren/uw-imap.git
Vcs-Browser: https://salsa.debian.org/holmgren/uw-imap
Homepage: http://www.washington.edu/imap/
Rules-Requires-Root: binary-targets

Package: libc-client2007e-dev
Section: libdevel
Architecture: any
Depends: ${devlibs:Depends},
 ${misc:Depends},
 libc-client2007e (= ${binary:Version})
Conflicts: libc-client-dev
Replaces: libc-client-dev
Provides: libc-client-dev
Description: c-client library for mail protocols - development files
 IMAP (Internet Message Access Protocol) is a method of accessing
 electronic messages kept on a (possibly shared) mail server.
 .
 The UW (University of Washington) IMAP toolkit provides the c-client
 mail-handling library supporting various network transport methods,
 file system storage formats, and authentication and authorization
 methods.
 .
 This package contains the static c-client library and development
 headers.

Package: libc-client2007e
Section: libs
Architecture: any
Depends: ${cdbs:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: ${cdbs:Suggests}
Description: c-client library for mail protocols - library files
 IMAP (Internet Message Access Protocol) is a method of accessing
 electronic messages kept on a (possibly shared) mail server.
 .
 The UW (University of Washington) IMAP toolkit provides the c-client
 mail-handling library supporting various network transport methods,
 file system storage formats, and authentication and authorization
 methods.
 .
 This package contains the shared c-client library.

Package: mlock
Section: mail
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: mailbox locking program
 IMAP (Internet Message Access Protocol) is a method of accessing
 electronic messages kept on a (possibly shared) mail server.
 .
 The UW (University of Washington) IMAP toolkit provides the c-client
 mail-handling library supporting various network transport methods,
 file system storage formats, and authentication and authorization
 methods.
 .
 This package contains a program to lock mailbox files to avoid
 corruption.

Package: uw-mailutils
Section: mail
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: c-client support programs
 IMAP (Internet Message Access Protocol) is a method of accessing
 electronic messages kept on a (possibly shared) mail server.
 .
 The UW (University of Washington) IMAP toolkit provides the c-client
 mail-handling library supporting various network transport methods,
 file system storage formats, and authentication and authorization
 methods.
 .
 This package contains helper tools for the libc-client library:
  - mailutil: utility program which helps manage email mailboxes (both
              local and IMAP/POP3/NNTP);
  - dmail:    MDA (Mail Delivery Agent) for use with procmail;
  - tmail:    MDA for use with the system mailer (such as Sendmail or Postfix).

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2011, 2012
# Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for IMAP Toolkit Environment
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to run before cdbs auto-update
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed $(SEDRULE_CONTENT) <debian/control.in.in >debian/control.in

include /usr/share/cdbs/1/class/langcore.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/upstream-tarball.mk

DEB_UPSTREAM_URL = ftp://ftp.cac.washington.edu/mail
DEB_UPSTREAM_PACKAGE = imap
DEB_UPSTREAM_TARBALL_MD5 = 2126fd125ea26b73b20f01fcd5940369

DEB_UPSTREAM_REPACKAGE_EXCLUDES = docs/rfc/ docs/draft/ src/osdep/mac/mtest.sit.hqx

major = 2007e
minor = 0

SEDRULE_FILENAME = -e 's/__VER__/$(major)/g'
SEDRULE_CONTENT = -e 's/__LIBVER__/$(major)/g' -e 's/__LIBFULLVER__/$(major).$(minor)/g' -e 's/__VER__/$(major)/g'

# Hardcode CDBS-resolved build flags, and stuff CPPFLAGS into CFLAGS
CFLAGS := $(deb_cflags) $(deb_cppflags)
LDFLAGS := $(deb_ldflags)

CFLAGS += -D_REENTRANT -DDISABLE_POP_PROXY

# Suppress seemingly non-fatal warnings to easer spot more important ones.
CFLAGS += -Wno-parentheses -Wno-strict-aliasing
#CFLAGS += -Wno-implicit-function-declaration

# Enforce symbol resolution at build time
# (suggested by Debian Policy 3.6.1 chapter 10.2)
SHLIBCFLAGS = -Wl,-z,defs

# Enable Kerberos V support
EXTRAAUTHENTICATORS = gss

# Upstream README is more of a README.build
DEB_INSTALL_DOCS_ALL =

pre-build::
	echo "sed $(SEDRULE_CONTENT) <debian/control.in.in | diff -u debian/control.in -"
	@sed $(SEDRULE_CONTENT) <debian/control.in.in | diff -u debian/control.in - || ( \
		echo; \
		echo "Upstream version has changed (or debian/control.in.in is out of sync)"; \
		echo "Edit debian/control manually, or use the following command:"; \
		echo "  DEB_MAINTAINER_MODE=1 fakeroot debian/rules clean"; \
		exit 1)

build-arch: debian/build-stamp
debian/build-stamp:
	dh_testdir

	# Debian libc is believed to be IPv6-safe
	touch ip6

	dh_auto_build -- VERSION=$(major) EXTRAAUTHENTICATORS='$(EXTRAAUTHENTICATORS)' EXTRACFLAGS='$(CFLAGS)' EXTRALDFLAGS='$(LDFLAGS)' ldb
	mv c-client/c-client.a .
	$(MAKE) clean
	# Use PAM
	dh_auto_build -- VERSION=$(major) EXTRAAUTHENTICATORS='$(EXTRAAUTHENTICATORS)' EXTRACFLAGS='$(CFLAGS) $(SHLIBCFLAGS)' EXTRALDFLAGS='$(LDFLAGS)' ldbs
	pod2man -c "" -r "UW IMAP $(DEB_NOEPOCH_VERSION)" debian/mlock.pod debian/mlock.1

	touch $@

clean::
	$(MAKE) clean
	for dir in $(DEB_PATCHDIRS); do rm -f $$dir/*.log; done
	rm -f c-client.a
	rm -f debian/build-stamp
	rm -f debian/mlock.1
	rm -rf RCS
	rm -f ip6

# Setup (and tear down) files containing variables static per build
pre-build::
	for file in `find debian -maxdepth 2 -type f -name '*.in' -not -name control.in -not -name control.in.in -not -name POTFILES.in`; do \
		targetfile=`echo $$file | sed $(SEDRULE_FILENAME) -e 's/\\.in$$//'`; \
		sed $(SEDRULE_CONTENT) <$$file >$$targetfile; \
	done

clean:: 
	for file in `find debian -maxdepth 2 -type f -name '*.in' -not -name control.in -not -name control.in.in -not -name README.source.in -not -name POTFILES.in -not -name 'watch.in'`; do \
		targetfile=`echo $$file | sed $(SEDRULE_FILENAME) -e 's/\\.in$$//'`; \
		rm -f $$targetfile; \
	done

# Install libs and resolve dev package dependencies
common-install-arch::
	mkdir -p debian/tmp/usr/lib
	install -m 0644 c-client.a debian/tmp/usr/lib/libc-client.a
	install -m 0644 c-client/libc-client.so debian/tmp/usr/lib/libc-client.so.$(major).$(minor)
	ln -s libc-client.so.$(major).$(minor) debian/tmp/usr/lib/libc-client.so.$(major)
	ln -s libc-client.so.$(major).$(minor) debian/tmp/usr/lib/libc-client.so
	mkdir -p debian/tmp/usr/include/c-client
	install -m 0644 -t debian/tmp/usr/include/c-client \
		src/c-client/*.h \
		src/osdep/unix/*.h \
		c-client/auths.c \
		c-client/linkage.c \
		c-client/linkage.h \
		c-client/osdep.h

common-binary-post-install-arch:: debian/install-libs-stamp

debian/install-libs-stamp:
	d-shlibmove --commit --override s/libkrb5-dev/krb5-multidev/ \
		--movedev "debian/tmp/usr/include/*" usr/include \
		debian/tmp/usr/lib/libc-client.so
	touch $@

clean::
	rm -f debian/install-libs-stamp

binary-predeb/mlock::
	chown root:mail debian/$(cdbs_curpkg)/usr/bin/mlock
	chmod 2755 debian/$(cdbs_curpkg)/usr/bin/mlock

# Refuse to ship with nonfree RFC files in source
clean::
	@echo "-find -name '*.txt' | grep rfc"
	@-find -name '*.txt' | grep rfc && ( \
		echo; \
		echo "ERROR: RFC documents found!"; \
		echo "RFC documents possibly do not comply with the Debian Free Software"; \
		echo "Guidelines, and thus better be stripped from the source tarball!"; \
		exit 1)

# Needed by upstream build process
CDBS_BUILD_DEPENDS += , libpam-dev, krb5-multidev, comerr-dev, libssl-dev

# Needed for our packaging routines
CDBS_BUILD_DEPENDS += , d-shlibs

# Needed (always/often/seldom) at runtime
CDBS_DEPENDS_libc-client$(major) = libpam-modules, mlock
CDBS_SUGGESTS_libc-client$(major) = uw-mailutils
